/* PopupWindow.c generated by valac 0.56.17, the Vala compiler
 * generated from PopupWindow.vala, do not modify */

/*
 * Copyright 2017 Adam Bieńkowski
 * Copyright 2023 elementary, Inc. <https://elementary.io>
 * SPDX-License-Identifier: GPL-3.0-or-later
 */

#include "gala-pip.h"
#include <glib.h>
#include "gala.h"
#include <meta/meta-window-actor.h>
#include <clutter/clutter.h>
#include <float.h>
#include <math.h>
#include <meta/window.h>
#include <glib-object.h>
#include <graphene-gobject.h>
#include <meta/meta-plugin.h>
#include <meta/display.h>
#include <meta/common.h>
#include <meta/meta-workspace-manager.h>
#include <meta/workspace.h>
#include <mtk/mtk.h>
#include <stdlib.h>
#include <string.h>

#define GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT ((guint) 200)
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE 0.1f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE 1.0f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN 0
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT 0.5f
#define GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS 80
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_0_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES
};
static GParamSpec* gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL,
	GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS
};
static guint gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_NUM_SIGNALS] = {0};

struct _GalaPluginsPIPPopupWindowPrivate {
	gint button_size;
	gint container_margin;
	GalaWindowManager* _wm;
	MetaWindowActor* _window_actor;
	gboolean dynamic_container;
	ClutterActor* clone;
	ClutterActor* container;
	GalaCloseButton* close_button;
	ClutterActor* resize_button;
	GalaDragDropAction* move_action;
	gfloat begin_resize_width;
	gfloat begin_resize_height;
	gfloat resize_start_x;
	gfloat resize_start_y;
	gboolean resizing;
	gboolean off_screen;
	ClutterGrab* grab;
};

struct _Block4Data {
	int _ref_count_;
	GalaPluginsPIPPopupWindow* self;
	gulong completed_id;
};

static gint GalaPluginsPIPPopupWindow_private_offset;
static gpointer gala_plugins_pip_popup_window_parent_class = NULL;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus;
static MetaWindow* gala_plugins_pip_popup_window_previous_focus = NULL;

static void gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                                    gfloat src_height,
                                                                    gfloat max_width,
                                                                    gfloat max_height,
                                                                    gfloat* width,
                                                                    gfloat* height);
static gboolean gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window);
static void gala_plugins_pip_popup_window_real_show (ClutterActor* base);
static void gala_plugins_pip_popup_window_real_hide (ClutterActor* base);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void ___lambda4_ (Block4Data* _data4_);
static void ____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                       gpointer self);
static gboolean gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                         ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                         ClutterEvent* event);
static void gala_plugins_pip_popup_window_update_container_scale (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self);
static ClutterActor* gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                               ClutterEvent* event);
static gboolean gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                                        ClutterEvent* event);
static gboolean _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                             ClutterEvent* event,
                                                                             gpointer self);
static void gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self);
static gboolean __lambda5_ (GalaPluginsPIPPopupWindow* self);
static gboolean ___lambda5__gsource_func (gpointer self);
static void gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                           gfloat* width,
                                                           gfloat* height);
static void gala_plugins_pip_popup_window_update_container_position (GalaPluginsPIPPopupWindow* self);
static gboolean gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self);
static void gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                             MtkRectangle* rect);
static gboolean gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                                  gfloat coord,
                                                                  ClutterOrientation axis);
static void gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self);
static GObject * gala_plugins_pip_popup_window_constructor (GType type,
                                                     guint n_construct_properties,
                                                     GObjectConstructParam * construct_properties);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                         GParamSpec* pspec,
                                                                         gpointer self);
static void _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                         gpointer self);
static ClutterActor* _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                                             gfloat x,
                                                                                             gfloat y,
                                                                                             gpointer self);
static void _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                     gpointer self);
static void _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                                  guint32 button,
                                                                                  gpointer self);
static void _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                        guint32 timestamp,
                                                                                        gpointer self);
static gboolean _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                                 ClutterEvent* event,
                                                                                                 gpointer self);
static void _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                           GParamSpec* pspec,
                                                                           gpointer self);
static void gala_plugins_pip_popup_window_finalize (GObject * obj);
static GType gala_plugins_pip_popup_window_get_type_once (void);
static void _vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);

static inline gpointer
gala_plugins_pip_popup_window_get_instance_private (GalaPluginsPIPPopupWindow* self)
{
	return G_STRUCT_MEMBER_P (self, GalaPluginsPIPPopupWindow_private_offset);
}

static void
gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (gfloat src_width,
                                                               gfloat src_height,
                                                               gfloat max_width,
                                                               gfloat max_height,
                                                               gfloat* width,
                                                               gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
	gfloat ratio = 0.0F;
#line 44 "../plugins/pip/PopupWindow.vala"
	ratio = MIN (max_width / src_width, max_height / src_height);
#line 45 "../plugins/pip/PopupWindow.vala"
	_vala_width = src_width * ratio;
#line 46 "../plugins/pip/PopupWindow.vala"
	_vala_height = src_height * ratio;
#line 42 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 42 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 207 "PopupWindow.c"
	}
#line 42 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 42 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 213 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_get_window_is_normal (MetaWindow* window)
{
	MetaWindowType window_type = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 49 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window != NULL, FALSE);
#line 50 "../plugins/pip/PopupWindow.vala"
	window_type = meta_window_get_window_type (window);
#line 51 "../plugins/pip/PopupWindow.vala"
	if (window_type == META_WINDOW_NORMAL) {
#line 51 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = TRUE;
#line 232 "PopupWindow.c"
	} else {
#line 52 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = window_type == META_WINDOW_DIALOG;
#line 236 "PopupWindow.c"
	}
#line 51 "../plugins/pip/PopupWindow.vala"
	if (_tmp1_) {
#line 51 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 242 "PopupWindow.c"
	} else {
#line 53 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = window_type == META_WINDOW_MODAL_DIALOG;
#line 246 "PopupWindow.c"
	}
#line 51 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 51 "../plugins/pip/PopupWindow.vala"
	return result;
#line 252 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_construct (GType object_type,
                                         GalaWindowManager* wm,
                                         MetaWindowActor* window_actor)
{
	GalaPluginsPIPPopupWindow * self = NULL;
#line 56 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (wm != NULL, NULL);
#line 56 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (window_actor != NULL, NULL);
#line 57 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) g_object_new (object_type, "wm", wm, "window-actor", window_actor, NULL);
#line 56 "../plugins/pip/PopupWindow.vala"
	return self;
#line 269 "PopupWindow.c"
}

GalaPluginsPIPPopupWindow*
gala_plugins_pip_popup_window_new (GalaWindowManager* wm,
                                   MetaWindowActor* window_actor)
{
#line 56 "../plugins/pip/PopupWindow.vala"
	return gala_plugins_pip_popup_window_construct (GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, wm, window_actor);
#line 278 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_show (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 137 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 138 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->show (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 140 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 142 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 143 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 143 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 143 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 143 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 143 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 200;
#line 307 "PopupWindow.c"
	} else {
#line 143 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 311 "PopupWindow.c"
	}
#line 143 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) _tmp0_);
#line 144 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 145 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 319 "PopupWindow.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 157 "../plugins/pip/PopupWindow.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 157 "../plugins/pip/PopupWindow.vala"
	return _data4_;
#line 329 "PopupWindow.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 157 "../plugins/pip/PopupWindow.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 339 "PopupWindow.c"
		GalaPluginsPIPPopupWindow* self;
#line 157 "../plugins/pip/PopupWindow.vala"
		self = _data4_->self;
#line 157 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self);
#line 157 "../plugins/pip/PopupWindow.vala"
		g_slice_free (Block4Data, _data4_);
#line 347 "PopupWindow.c"
	}
}

static void
___lambda4_ (Block4Data* _data4_)
{
	GalaPluginsPIPPopupWindow* self;
#line 161 "../plugins/pip/PopupWindow.vala"
	self = _data4_->self;
#line 162 "../plugins/pip/PopupWindow.vala"
	g_signal_handler_disconnect ((GObject*) self, _data4_->completed_id);
#line 163 "../plugins/pip/PopupWindow.vala"
	CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 361 "PopupWindow.c"
}

static void
____lambda4__clutter_actor_transitions_completed (ClutterActor* _sender,
                                                  gpointer self)
{
#line 161 "../plugins/pip/PopupWindow.vala"
	___lambda4_ (self);
#line 370 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_real_hide (ClutterActor* base)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
#line 148 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 149 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 255);
#line 151 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 151 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 151 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 151 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 151 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 200;
#line 396 "PopupWindow.c"
	} else {
#line 151 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 400 "PopupWindow.c"
	}
#line 151 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 152 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 153 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 154 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 155 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 157 "../plugins/pip/PopupWindow.vala"
	if (duration == 0) {
#line 158 "../plugins/pip/PopupWindow.vala"
		CLUTTER_ACTOR_CLASS (gala_plugins_pip_popup_window_parent_class)->hide (G_TYPE_CHECK_INSTANCE_CAST (self, clutter_actor_get_type (), ClutterActor));
#line 416 "PopupWindow.c"
	} else {
		Block4Data* _data4_;
		gulong _tmp4_;
#line 157 "../plugins/pip/PopupWindow.vala"
		_data4_ = g_slice_new0 (Block4Data);
#line 157 "../plugins/pip/PopupWindow.vala"
		_data4_->_ref_count_ = 1;
#line 157 "../plugins/pip/PopupWindow.vala"
		_data4_->self = g_object_ref (self);
#line 160 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = (gulong) 0;
#line 161 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = g_signal_connect_data ((ClutterActor*) self, "transitions-completed", (GCallback) ____lambda4__clutter_actor_transitions_completed, block4_data_ref (_data4_), (GClosureNotify) block4_data_unref, 0);
#line 161 "../plugins/pip/PopupWindow.vala"
		_data4_->completed_id = _tmp4_;
#line 157 "../plugins/pip/PopupWindow.vala"
		block4_data_unref (_data4_);
#line 157 "../plugins/pip/PopupWindow.vala"
		_data4_ = NULL;
#line 436 "PopupWindow.c"
	}
}

static gboolean
gala_plugins_pip_popup_window_real_enter_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	GalaCloseButton* _tmp4_;
	GalaCloseButton* _tmp5_;
	GalaCloseButton* _tmp6_;
	GalaCloseButton* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	gboolean result;
#line 169 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 169 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 173 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 173 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 173 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 173 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 173 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 473 "PopupWindow.c"
	} else {
#line 173 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 477 "PopupWindow.c"
	}
#line 173 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 175 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->close_button;
#line 175 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp4_);
#line 176 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->close_button;
#line 176 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp5_, (guint) duration);
#line 177 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->close_button;
#line 177 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp6_, (guint) 255);
#line 178 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->close_button;
#line 178 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp7_);
#line 180 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->resize_button;
#line 180 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp8_);
#line 181 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 181 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp9_, (guint) duration);
#line 182 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->resize_button;
#line 182 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp10_, (guint) 255);
#line 183 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 183 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp11_);
#line 185 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 185 "../plugins/pip/PopupWindow.vala"
	return result;
#line 517 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_real_leave_event (ClutterActor* base,
                                                ClutterEvent* event)
{
	GalaPluginsPIPPopupWindow * self;
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	GalaCloseButton* _tmp4_;
	GalaCloseButton* _tmp5_;
	GalaCloseButton* _tmp6_;
	GalaCloseButton* _tmp7_;
	ClutterActor* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterActor* _tmp10_;
	ClutterActor* _tmp11_;
	gboolean result;
#line 189 "../plugins/pip/PopupWindow.vala"
	self = (GalaPluginsPIPPopupWindow*) base;
#line 189 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 193 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 193 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 193 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 193 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 193 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 553 "PopupWindow.c"
	} else {
#line 193 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 557 "PopupWindow.c"
	}
#line 193 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 195 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->close_button;
#line 195 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) _tmp4_);
#line 196 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = self->priv->close_button;
#line 196 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) _tmp5_, (guint) duration);
#line 197 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = self->priv->close_button;
#line 197 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp6_, (guint) 0);
#line 198 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->close_button;
#line 198 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) _tmp7_);
#line 200 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->resize_button;
#line 200 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state (_tmp8_);
#line 201 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 201 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration (_tmp9_, (guint) duration);
#line 202 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->resize_button;
#line 202 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp10_, (guint) 0);
#line 203 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 203 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state (_tmp11_);
#line 205 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 205 "../plugins/pip/PopupWindow.vala"
	return result;
#line 597 "PopupWindow.c"
}

void
gala_plugins_pip_popup_window_set_container_clip (GalaPluginsPIPPopupWindow* self,
                                                  graphene_rect_t* container_clip)
{
	ClutterActor* _tmp0_;
	graphene_rect_t _tmp1_;
#line 208 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 209 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->container;
#line 209 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = *container_clip;
#line 209 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp0_, "clip-rect", &_tmp1_, NULL);
#line 210 "../plugins/pip/PopupWindow.vala"
	self->priv->dynamic_container = TRUE;
#line 211 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_container_scale (self);
#line 212 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed (self);
#line 620 "PopupWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 218 "../plugins/pip/PopupWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 628 "PopupWindow.c"
}

static ClutterActor*
gala_plugins_pip_popup_window_on_move_begin (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	ClutterActor* _tmp2_;
	ClutterActor* result;
#line 215 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 216 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 216 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp1_, META_CURSOR_DND_IN_DRAG);
#line 218 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 ((ClutterActor*) self);
#line 218 "../plugins/pip/PopupWindow.vala"
	result = _tmp2_;
#line 218 "../plugins/pip/PopupWindow.vala"
	return result;
#line 652 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_move_end (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
#line 221 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 222 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 223 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 224 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 224 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 224 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp1_, META_CURSOR_DEFAULT);
#line 672 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event (ClutterActor* _sender,
                                                                    ClutterEvent* event,
                                                                    gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_event ((GalaPluginsPIPPopupWindow*) self, event);
#line 244 "../plugins/pip/PopupWindow.vala"
	return result;
#line 684 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_button_press (GalaPluginsPIPPopupWindow* self,
                                                      ClutterEvent* event)
{
	gboolean _tmp0_ = FALSE;
	gfloat _tmp1_ = 0.0F;
	gfloat _tmp2_ = 0.0F;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	ClutterActor* _tmp7_;
	ClutterStage* _tmp8_;
	ClutterActor* _tmp9_;
	ClutterGrab* _tmp10_;
	ClutterActor* _tmp11_;
	GalaWindowManager* _tmp12_;
	MetaDisplay* _tmp13_;
	gboolean result;
#line 228 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 228 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 232 "../plugins/pip/PopupWindow.vala"
	if (self->priv->resizing) {
#line 232 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = TRUE;
#line 714 "PopupWindow.c"
	} else {
#line 232 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = clutter_event_get_button (event) != CLUTTER_BUTTON_PRIMARY;
#line 718 "PopupWindow.c"
	}
#line 232 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_) {
#line 233 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 233 "../plugins/pip/PopupWindow.vala"
		return result;
#line 726 "PopupWindow.c"
	}
#line 236 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = TRUE;
#line 238 "../plugins/pip/PopupWindow.vala"
	clutter_event_get_coords (event, &_tmp1_, &_tmp2_);
#line 238 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = _tmp1_;
#line 238 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = _tmp2_;
#line 240 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = clutter_actor_get_width ((ClutterActor*) self);
#line 240 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = _tmp3_;
#line 240 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = _tmp4_;
#line 241 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_height ((ClutterActor*) self);
#line 241 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 241 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = _tmp6_;
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = self->priv->resize_button;
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = clutter_actor_get_stage (_tmp7_);
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = self->priv->resize_button;
#line 243 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = clutter_stage_grab (_tmp8_, _tmp9_);
#line 243 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 243 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = _tmp10_;
#line 244 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->resize_button;
#line 244 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp11_, "event", (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self, 0);
#line 246 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->_wm;
#line 246 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_plugin_get_display ((MetaPlugin*) _tmp12_);
#line 246 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp13_, META_CURSOR_SE_RESIZE);
#line 248 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_PROPAGATE;
#line 248 "../plugins/pip/PopupWindow.vala"
	return result;
#line 774 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_on_resize_event (GalaPluginsPIPPopupWindow* self,
                                               ClutterEvent* event)
{
	gboolean result;
#line 251 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 251 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 252 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 253 "../plugins/pip/PopupWindow.vala"
		result = CLUTTER_EVENT_STOP;
#line 253 "../plugins/pip/PopupWindow.vala"
		return result;
#line 792 "PopupWindow.c"
	}
#line 256 "../plugins/pip/PopupWindow.vala"
	switch (clutter_event_type (event)) {
#line 256 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_MOTION:
#line 798 "PopupWindow.c"
		{
			ClutterModifierType mods = 0U;
			gfloat event_x = 0.0F;
			gfloat event_y = 0.0F;
			gfloat _tmp0_ = 0.0F;
			gfloat _tmp1_ = 0.0F;
			gfloat diff_x = 0.0F;
			gfloat diff_y = 0.0F;
#line 258 "../plugins/pip/PopupWindow.vala"
			mods = clutter_event_get_state (event);
#line 259 "../plugins/pip/PopupWindow.vala"
			if (!((mods & CLUTTER_BUTTON1_MASK) == CLUTTER_BUTTON1_MASK)) {
#line 260 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 261 "../plugins/pip/PopupWindow.vala"
				break;
#line 815 "PopupWindow.c"
			}
#line 265 "../plugins/pip/PopupWindow.vala"
			clutter_event_get_coords (event, &_tmp0_, &_tmp1_);
#line 265 "../plugins/pip/PopupWindow.vala"
			event_x = _tmp0_;
#line 265 "../plugins/pip/PopupWindow.vala"
			event_y = _tmp1_;
#line 266 "../plugins/pip/PopupWindow.vala"
			diff_x = event_x - self->priv->resize_start_x;
#line 267 "../plugins/pip/PopupWindow.vala"
			diff_y = event_y - self->priv->resize_start_y;
#line 269 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_width ((ClutterActor*) self, self->priv->begin_resize_width + diff_x);
#line 270 "../plugins/pip/PopupWindow.vala"
			clutter_actor_set_height ((ClutterActor*) self, self->priv->begin_resize_height + diff_y);
#line 272 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_container_scale (self);
#line 273 "../plugins/pip/PopupWindow.vala"
			gala_plugins_pip_popup_window_update_size (self);
#line 275 "../plugins/pip/PopupWindow.vala"
			break;
#line 837 "PopupWindow.c"
		}
#line 256 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_BUTTON_RELEASE:
#line 841 "PopupWindow.c"
		{
#line 277 "../plugins/pip/PopupWindow.vala"
			if (clutter_event_get_button (event) == CLUTTER_BUTTON_PRIMARY) {
#line 278 "../plugins/pip/PopupWindow.vala"
				gala_plugins_pip_popup_window_stop_resizing (self);
#line 847 "PopupWindow.c"
			}
#line 281 "../plugins/pip/PopupWindow.vala"
			break;
#line 851 "PopupWindow.c"
		}
#line 256 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_LEAVE:
#line 256 "../plugins/pip/PopupWindow.vala"
		case CLUTTER_ENTER:
#line 857 "PopupWindow.c"
		{
#line 284 "../plugins/pip/PopupWindow.vala"
			result = CLUTTER_EVENT_PROPAGATE;
#line 284 "../plugins/pip/PopupWindow.vala"
			return result;
#line 863 "PopupWindow.c"
		}
		default:
		{
#line 286 "../plugins/pip/PopupWindow.vala"
			break;
#line 869 "PopupWindow.c"
		}
	}
#line 289 "../plugins/pip/PopupWindow.vala"
	result = CLUTTER_EVENT_STOP;
#line 289 "../plugins/pip/PopupWindow.vala"
	return result;
#line 876 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_stop_resizing (GalaPluginsPIPPopupWindow* self)
{
	ClutterGrab* _tmp0_;
	GalaWindowManager* _tmp4_;
	MetaDisplay* _tmp5_;
#line 292 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 293 "../plugins/pip/PopupWindow.vala"
	if (!self->priv->resizing) {
#line 294 "../plugins/pip/PopupWindow.vala"
		return;
#line 891 "PopupWindow.c"
	}
#line 297 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->grab;
#line 297 "../plugins/pip/PopupWindow.vala"
	if (_tmp0_ != NULL) {
#line 897 "PopupWindow.c"
		ClutterGrab* _tmp1_;
		ClutterActor* _tmp2_;
		guint _tmp3_;
#line 298 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = self->priv->grab;
#line 298 "../plugins/pip/PopupWindow.vala"
		clutter_grab_dismiss (_tmp1_);
#line 299 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = self->priv->resize_button;
#line 299 "../plugins/pip/PopupWindow.vala"
		g_signal_parse_name ("event", clutter_actor_get_type (), &_tmp3_, NULL, FALSE);
#line 299 "../plugins/pip/PopupWindow.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _gala_plugins_pip_popup_window_on_resize_event_clutter_actor_event, self);
#line 300 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->grab);
#line 300 "../plugins/pip/PopupWindow.vala"
		self->priv->grab = NULL;
#line 915 "PopupWindow.c"
	}
#line 303 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 305 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_screen_position (self);
#line 307 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_wm;
#line 307 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = meta_plugin_get_display ((MetaPlugin*) _tmp4_);
#line 307 "../plugins/pip/PopupWindow.vala"
	meta_display_set_cursor (_tmp5_, META_CURSOR_DEFAULT);
#line 927 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_allocation_changed (GalaPluginsPIPPopupWindow* self)
{
#line 310 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 311 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 312 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 939 "PopupWindow.c"
}

static gboolean
__lambda5_ (GalaPluginsPIPPopupWindow* self)
{
	gboolean result;
#line 324 "../plugins/pip/PopupWindow.vala"
	g_signal_emit (self, gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL], 0);
#line 325 "../plugins/pip/PopupWindow.vala"
	result = G_SOURCE_REMOVE;
#line 325 "../plugins/pip/PopupWindow.vala"
	return result;
#line 952 "PopupWindow.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ ((GalaPluginsPIPPopupWindow*) self);
#line 323 "../plugins/pip/PopupWindow.vala"
	return result;
#line 962 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_on_close_click_clicked (GalaPluginsPIPPopupWindow* self)
{
	guint _tmp0_ = 0U;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	guint duration = 0U;
#line 315 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 316 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 316 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 316 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 316 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 316 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = GALA_PLUGINS_PIP_POPUP_WINDOW_FADE_OUT_TIMEOUT;
#line 985 "PopupWindow.c"
	} else {
#line 316 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = (guint) 0;
#line 989 "PopupWindow.c"
	}
#line 316 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 318 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 319 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, duration);
#line 320 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) self, (guint) 0);
#line 321 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 323 "../plugins/pip/PopupWindow.vala"
	clutter_threads_add_timeout (duration, ___lambda5__gsource_func, self);
#line 1003 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_window_focus (GalaPluginsPIPPopupWindow* self)
{
	MetaWindow* focus_window = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	MetaWindow* _tmp5_;
	MetaWorkspaceManager* workspace_manager = NULL;
	GalaWindowManager* _tmp11_;
	MetaDisplay* _tmp12_;
	MetaWorkspaceManager* _tmp13_;
	MetaWorkspace* active_workspace = NULL;
	MetaWorkspaceManager* _tmp14_;
	MetaWorkspace* _tmp15_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp16_;
	MetaWindow* _tmp17_;
	gboolean _tmp18_ = FALSE;
	MetaWindow* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	MetaWindow* _tmp25_;
#line 329 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 330 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 330 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 330 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = meta_display_get_focus_window (_tmp1_);
#line 330 "../plugins/pip/PopupWindow.vala"
	focus_window = _tmp2_;
#line 331 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = focus_window;
#line 331 "../plugins/pip/PopupWindow.vala"
	if (_tmp5_ != NULL) {
#line 1045 "PopupWindow.c"
		MetaWindow* _tmp6_;
#line 331 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = focus_window;
#line 331 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp6_);
#line 1051 "PopupWindow.c"
	} else {
#line 331 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = FALSE;
#line 1055 "PopupWindow.c"
	}
#line 331 "../plugins/pip/PopupWindow.vala"
	if (_tmp4_) {
#line 331 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = TRUE;
#line 1061 "PopupWindow.c"
	} else {
		gboolean _tmp7_ = FALSE;
		MetaWindow* _tmp8_;
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = gala_plugins_pip_popup_window_previous_focus;
#line 332 "../plugins/pip/PopupWindow.vala"
		if (_tmp8_ != NULL) {
#line 1069 "PopupWindow.c"
			MetaWindow* _tmp9_;
#line 332 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = gala_plugins_pip_popup_window_previous_focus;
#line 332 "../plugins/pip/PopupWindow.vala"
			_tmp7_ = !gala_plugins_pip_popup_window_get_window_is_normal (_tmp9_);
#line 1075 "PopupWindow.c"
		} else {
#line 332 "../plugins/pip/PopupWindow.vala"
			_tmp7_ = FALSE;
#line 1079 "PopupWindow.c"
		}
#line 332 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = _tmp7_;
#line 1083 "PopupWindow.c"
	}
#line 331 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 1087 "PopupWindow.c"
		MetaWindow* _tmp10_;
#line 333 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = focus_window;
#line 333 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_previous_focus = _tmp10_;
#line 334 "../plugins/pip/PopupWindow.vala"
		return;
#line 1095 "PopupWindow.c"
	}
#line 337 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->_wm;
#line 337 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = meta_plugin_get_display ((MetaPlugin*) _tmp11_);
#line 337 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = meta_display_get_workspace_manager (_tmp12_);
#line 337 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp13_;
#line 338 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = workspace_manager;
#line 338 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = meta_workspace_manager_get_active_workspace (_tmp14_);
#line 338 "../plugins/pip/PopupWindow.vala"
	active_workspace = _tmp15_;
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = self->priv->_window_actor;
#line 339 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = meta_window_actor_get_meta_window (_tmp16_);
#line 339 "../plugins/pip/PopupWindow.vala"
	window = _tmp17_;
#line 341 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = window;
#line 341 "../plugins/pip/PopupWindow.vala"
	g_object_get (_tmp19_, "appears-focused", &_tmp20_, NULL);
#line 341 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = _tmp20_;
#line 341 "../plugins/pip/PopupWindow.vala"
	if (_tmp21_) {
#line 1125 "PopupWindow.c"
		MetaWindow* _tmp22_;
		MetaWorkspace* _tmp23_;
#line 341 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = window;
#line 341 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = active_workspace;
#line 341 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = meta_window_located_on_workspace (_tmp22_, _tmp23_);
#line 1134 "PopupWindow.c"
	} else {
#line 341 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = FALSE;
#line 1138 "PopupWindow.c"
	}
#line 341 "../plugins/pip/PopupWindow.vala"
	if (_tmp18_) {
#line 342 "../plugins/pip/PopupWindow.vala"
		clutter_actor_hide ((ClutterActor*) self);
#line 1144 "PopupWindow.c"
	} else {
		MetaWindowActor* _tmp24_;
#line 343 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = self->priv->_window_actor;
#line 343 "../plugins/pip/PopupWindow.vala"
		if (!meta_window_actor_is_destroyed (_tmp24_)) {
#line 344 "../plugins/pip/PopupWindow.vala"
			clutter_actor_show ((ClutterActor*) self);
#line 1153 "PopupWindow.c"
		}
	}
#line 347 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = focus_window;
#line 347 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_previous_focus = _tmp25_;
#line 1160 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_size (GalaPluginsPIPPopupWindow* self)
{
#line 350 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 351 "../plugins/pip/PopupWindow.vala"
	if (self->priv->dynamic_container) {
#line 1170 "PopupWindow.c"
		gfloat src_width = 0.0F;
		gfloat src_height = 0.0F;
		ClutterActor* _tmp0_;
		gfloat _tmp1_ = 0.0F;
		gfloat _tmp2_ = 0.0F;
		ClutterActor* _tmp3_;
		gdouble _tmp4_;
		gdouble _tmp5_;
		ClutterActor* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
#line 352 "../plugins/pip/PopupWindow.vala"
		src_width = 0.0f;
#line 352 "../plugins/pip/PopupWindow.vala"
		src_height = 0.0f;
#line 353 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->container;
#line 353 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp0_, NULL, NULL, &_tmp1_, &_tmp2_);
#line 353 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp1_;
#line 353 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp2_;
#line 354 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->container;
#line 354 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp3_, "scale-x", &_tmp4_, NULL);
#line 354 "../plugins/pip/PopupWindow.vala"
		_tmp5_ = _tmp4_;
#line 354 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_width ((ClutterActor*) self, (gfloat) ((gint) ((src_width * _tmp5_) + self->priv->button_size)));
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->container;
#line 355 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp6_, "scale-y", &_tmp7_, NULL);
#line 355 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 355 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_height ((ClutterActor*) self, (gfloat) ((gint) ((src_height * _tmp8_) + self->priv->button_size)));
#line 1210 "PopupWindow.c"
	} else {
		ClutterActor* _tmp9_;
		gfloat _tmp10_;
		gfloat _tmp11_;
		ClutterActor* _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		ClutterActor* _tmp15_;
		gfloat _tmp16_;
		gfloat _tmp17_;
		ClutterActor* _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = self->priv->container;
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = clutter_actor_get_width (_tmp9_);
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp11_ = _tmp10_;
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp12_ = self->priv->container;
#line 357 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp12_, "scale-x", &_tmp13_, NULL);
#line 357 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = _tmp13_;
#line 357 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_width ((ClutterActor*) self, (gfloat) ((gint) ((_tmp11_ * _tmp14_) + self->priv->button_size)));
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = self->priv->container;
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = clutter_actor_get_height (_tmp15_);
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp18_ = self->priv->container;
#line 358 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp18_, "scale-y", &_tmp19_, NULL);
#line 358 "../plugins/pip/PopupWindow.vala"
		_tmp20_ = _tmp19_;
#line 358 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_height ((ClutterActor*) self, (gfloat) ((gint) ((_tmp17_ * _tmp20_) + self->priv->button_size)));
#line 1252 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_update_clone_clip (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle rect = {0};
	MetaWindowActor* _tmp0_;
	MetaWindow* _tmp1_;
	MtkRectangle _tmp2_ = {0};
	gfloat x_offset = 0.0F;
	MtkRectangle _tmp3_;
	MetaWindowActor* _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat y_offset = 0.0F;
	MtkRectangle _tmp7_;
	MetaWindowActor* _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	ClutterActor* _tmp11_;
	MtkRectangle _tmp12_;
	MtkRectangle _tmp13_;
	ClutterActor* _tmp14_;
	ClutterActor* _tmp15_;
	MtkRectangle _tmp16_;
	MtkRectangle _tmp17_;
#line 362 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 363 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 363 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 363 "../plugins/pip/PopupWindow.vala"
	meta_window_get_frame_rect (_tmp1_, &_tmp2_);
#line 363 "../plugins/pip/PopupWindow.vala"
	rect = _tmp2_;
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = rect;
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_x ((ClutterActor*) _tmp4_);
#line 365 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 365 "../plugins/pip/PopupWindow.vala"
	x_offset = _tmp3_.x - _tmp6_;
#line 366 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = rect;
#line 366 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->_window_actor;
#line 366 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_y ((ClutterActor*) _tmp8_);
#line 366 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 366 "../plugins/pip/PopupWindow.vala"
	y_offset = _tmp7_.y - _tmp10_;
#line 367 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = self->priv->clone;
#line 367 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = rect;
#line 367 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = rect;
#line 367 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_clip (_tmp11_, x_offset, y_offset, (gfloat) _tmp12_.width, (gfloat) _tmp13_.height);
#line 368 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = self->priv->clone;
#line 368 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position (_tmp14_, -x_offset, -y_offset);
#line 370 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->container;
#line 370 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = rect;
#line 370 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = rect;
#line 370 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_size (_tmp15_, (gfloat) _tmp16_.width, (gfloat) _tmp17_.height);
#line 1330 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_container_scale (GalaPluginsPIPPopupWindow* self)
{
	gfloat src_width = 0.0F;
	gfloat src_height = 0.0F;
	gfloat max_width = 0.0F;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat max_height = 0.0F;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gfloat new_width = 0.0F;
	gfloat new_height = 0.0F;
	gfloat _tmp13_ = 0.0F;
	gfloat _tmp14_ = 0.0F;
	gfloat window_width = 0.0F;
	gfloat window_height = 0.0F;
	gfloat _tmp15_ = 0.0F;
	gfloat _tmp16_ = 0.0F;
	gfloat new_scale_x = 0.0F;
	gfloat new_scale_y = 0.0F;
	ClutterActor* _tmp17_;
	ClutterActor* _tmp18_;
#line 373 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 374 "../plugins/pip/PopupWindow.vala"
	src_width = 1.0f;
#line 374 "../plugins/pip/PopupWindow.vala"
	src_height = 1.0f;
#line 375 "../plugins/pip/PopupWindow.vala"
	if (self->priv->dynamic_container) {
#line 1364 "PopupWindow.c"
		ClutterActor* _tmp0_;
		gfloat _tmp1_ = 0.0F;
		gfloat _tmp2_ = 0.0F;
#line 376 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->container;
#line 376 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp0_, NULL, NULL, &_tmp1_, &_tmp2_);
#line 376 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp1_;
#line 376 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp2_;
#line 1376 "PopupWindow.c"
	} else {
		ClutterActor* _tmp3_;
		gfloat _tmp4_;
		gfloat _tmp5_;
		ClutterActor* _tmp6_;
		gfloat _tmp7_;
		gfloat _tmp8_;
#line 378 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->container;
#line 378 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = clutter_actor_get_width (_tmp3_);
#line 378 "../plugins/pip/PopupWindow.vala"
		_tmp5_ = _tmp4_;
#line 378 "../plugins/pip/PopupWindow.vala"
		src_width = _tmp5_;
#line 379 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = self->priv->container;
#line 379 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = clutter_actor_get_height (_tmp6_);
#line 379 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = _tmp7_;
#line 379 "../plugins/pip/PopupWindow.vala"
		src_height = _tmp8_;
#line 1400 "PopupWindow.c"
	}
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_width ((ClutterActor*) self);
#line 382 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 382 "../plugins/pip/PopupWindow.vala"
	max_width = _tmp10_ - self->priv->button_size;
#line 383 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = clutter_actor_get_height ((ClutterActor*) self);
#line 383 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 383 "../plugins/pip/PopupWindow.vala"
	max_height = _tmp12_ - self->priv->button_size;
#line 386 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_calculate_aspect_ratio_size_fit (src_width, src_height, max_width, max_height, &_tmp13_, &_tmp14_);
#line 386 "../plugins/pip/PopupWindow.vala"
	new_width = _tmp13_;
#line 386 "../plugins/pip/PopupWindow.vala"
	new_height = _tmp14_;
#line 392 "../plugins/pip/PopupWindow.vala"
	window_width = 1.0f;
#line 392 "../plugins/pip/PopupWindow.vala"
	window_height = 1.0f;
#line 393 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_target_window_size (self, &_tmp15_, &_tmp16_);
#line 393 "../plugins/pip/PopupWindow.vala"
	window_width = _tmp15_;
#line 393 "../plugins/pip/PopupWindow.vala"
	window_height = _tmp16_;
#line 395 "../plugins/pip/PopupWindow.vala"
	new_scale_x = new_width / window_width;
#line 396 "../plugins/pip/PopupWindow.vala"
	new_scale_y = new_height / window_height;
#line 398 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = self->priv->container;
#line 398 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp17_, "scale-x", (gdouble) CLAMP (new_scale_x, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 399 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = self->priv->container;
#line 399 "../plugins/pip/PopupWindow.vala"
	g_object_set (_tmp18_, "scale-y", (gdouble) CLAMP (new_scale_y, GALA_PLUGINS_PIP_POPUP_WINDOW_MINIMUM_SCALE, GALA_PLUGINS_PIP_POPUP_WINDOW_MAXIMUM_SCALE), NULL);
#line 401 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_container_position (self);
#line 1444 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_update_container_position (GalaPluginsPIPPopupWindow* self)
{
#line 404 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 405 "../plugins/pip/PopupWindow.vala"
	if (self->priv->dynamic_container) {
#line 1454 "PopupWindow.c"
		gfloat clip_x = 0.0F;
		gfloat clip_y = 0.0F;
		ClutterActor* _tmp0_;
		gfloat _tmp1_ = 0.0F;
		gfloat _tmp2_ = 0.0F;
		ClutterActor* _tmp3_;
		ClutterActor* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		ClutterActor* _tmp7_;
		ClutterActor* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
#line 406 "../plugins/pip/PopupWindow.vala"
		clip_x = 0.0f;
#line 406 "../plugins/pip/PopupWindow.vala"
		clip_y = 0.0f;
#line 407 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->container;
#line 407 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp0_, &_tmp1_, &_tmp2_, NULL, NULL);
#line 407 "../plugins/pip/PopupWindow.vala"
		clip_x = _tmp1_;
#line 407 "../plugins/pip/PopupWindow.vala"
		clip_y = _tmp2_;
#line 408 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->container;
#line 408 "../plugins/pip/PopupWindow.vala"
		_tmp4_ = self->priv->container;
#line 408 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp4_, "scale-x", &_tmp5_, NULL);
#line 408 "../plugins/pip/PopupWindow.vala"
		_tmp6_ = _tmp5_;
#line 408 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x (_tmp3_, (gfloat) (((-clip_x) * _tmp6_) + self->priv->container_margin));
#line 409 "../plugins/pip/PopupWindow.vala"
		_tmp7_ = self->priv->container;
#line 409 "../plugins/pip/PopupWindow.vala"
		_tmp8_ = self->priv->container;
#line 409 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp8_, "scale-y", &_tmp9_, NULL);
#line 409 "../plugins/pip/PopupWindow.vala"
		_tmp10_ = _tmp9_;
#line 409 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y (_tmp7_, (gfloat) (((-clip_y) * _tmp10_) + self->priv->container_margin));
#line 1500 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_update_screen_position (GalaPluginsPIPPopupWindow* self)
{
#line 413 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 414 "../plugins/pip/PopupWindow.vala"
	if (!gala_plugins_pip_popup_window_place_window_off_screen (self)) {
#line 415 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 1513 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_place_window_in_screen (GalaPluginsPIPPopupWindow* self)
{
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp0_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp1_;
	gint monitor_y = 0;
	MtkRectangle _tmp2_;
	gint monitor_width = 0;
	MtkRectangle _tmp3_;
	gint monitor_height = 0;
	MtkRectangle _tmp4_;
	gint screen_limit_start_x = 0;
	gfloat screen_limit_end_x = 0.0F;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gint screen_limit_start_y = 0;
	gfloat screen_limit_end_y = 0.0F;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gint _tmp9_ = 0;
	GalaWindowManager* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	gint duration = 0;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
#line 419 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 420 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 427 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp0_);
#line 427 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp0_;
#line 429 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = monitor_rect;
#line 429 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp1_.x;
#line 430 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = monitor_rect;
#line 430 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp2_.y;
#line 431 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = monitor_rect;
#line 431 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp3_.width;
#line 432 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = monitor_rect;
#line 432 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp4_.height;
#line 434 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_x = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_x;
#line 435 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = clutter_actor_get_width ((ClutterActor*) self);
#line 435 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = _tmp5_;
#line 435 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_x = ((monitor_width + monitor_x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp6_;
#line 436 "../plugins/pip/PopupWindow.vala"
	screen_limit_start_y = GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + monitor_y;
#line 437 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = clutter_actor_get_height ((ClutterActor*) self);
#line 437 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = _tmp7_;
#line 437 "../plugins/pip/PopupWindow.vala"
	screen_limit_end_y = ((monitor_height + monitor_y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp8_;
#line 439 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = self->priv->_wm;
#line 439 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = gala_window_manager_get_enable_animations (_tmp10_);
#line 439 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 439 "../plugins/pip/PopupWindow.vala"
	if (_tmp12_) {
#line 439 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = 300;
#line 1597 "PopupWindow.c"
	} else {
#line 439 "../plugins/pip/PopupWindow.vala"
		_tmp9_ = 0;
#line 1601 "PopupWindow.c"
	}
#line 439 "../plugins/pip/PopupWindow.vala"
	duration = _tmp9_;
#line 441 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 442 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 443 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 444 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = clutter_actor_get_x ((ClutterActor*) self);
#line 444 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = _tmp13_;
#line 444 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_x ((ClutterActor*) self, CLAMP (_tmp14_, (gfloat) screen_limit_start_x, screen_limit_end_x));
#line 445 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = clutter_actor_get_y ((ClutterActor*) self);
#line 445 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = _tmp15_;
#line 445 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_y ((ClutterActor*) self, CLAMP (_tmp16_, (gfloat) screen_limit_start_y, screen_limit_end_y));
#line 446 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 1625 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_place_window_off_screen (GalaPluginsPIPPopupWindow* self)
{
	gint _tmp0_ = 0;
	GalaWindowManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gint duration = 0;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp4_ = {0};
	gint monitor_x = 0;
	MtkRectangle _tmp5_;
	gint monitor_y = 0;
	MtkRectangle _tmp6_;
	gint monitor_width = 0;
	MtkRectangle _tmp7_;
	gint monitor_height = 0;
	MtkRectangle _tmp8_;
	gfloat off_screen_x_threshold = 0.0F;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gboolean off_screen_x = FALSE;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gboolean _tmp13_ = FALSE;
	gboolean off_screen_w = FALSE;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gboolean _tmp22_ = FALSE;
	gfloat off_screen_y_threshold = 0.0F;
	gfloat _tmp27_;
	gfloat _tmp28_;
	gboolean off_screen_y = FALSE;
	gfloat _tmp29_;
	gfloat _tmp30_;
	gboolean _tmp31_ = FALSE;
	gboolean off_screen_h = FALSE;
	gfloat _tmp36_;
	gfloat _tmp37_;
	gfloat _tmp38_;
	gfloat _tmp39_;
	gboolean _tmp40_ = FALSE;
	gboolean result;
#line 449 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 450 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = self->priv->_wm;
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = gala_window_manager_get_enable_animations (_tmp1_);
#line 452 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = _tmp2_;
#line 452 "../plugins/pip/PopupWindow.vala"
	if (_tmp3_) {
#line 452 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 300;
#line 1687 "PopupWindow.c"
	} else {
#line 452 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = 0;
#line 1691 "PopupWindow.c"
	}
#line 452 "../plugins/pip/PopupWindow.vala"
	duration = _tmp0_;
#line 454 "../plugins/pip/PopupWindow.vala"
	clutter_actor_save_easing_state ((ClutterActor*) self);
#line 455 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_OUT_BACK);
#line 456 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_duration ((ClutterActor*) self, (guint) duration);
#line 463 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp4_);
#line 463 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp4_;
#line 465 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = monitor_rect;
#line 465 "../plugins/pip/PopupWindow.vala"
	monitor_x = _tmp5_.x;
#line 466 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = monitor_rect;
#line 466 "../plugins/pip/PopupWindow.vala"
	monitor_y = _tmp6_.y;
#line 467 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = monitor_rect;
#line 467 "../plugins/pip/PopupWindow.vala"
	monitor_width = _tmp7_.width;
#line 468 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = monitor_rect;
#line 468 "../plugins/pip/PopupWindow.vala"
	monitor_height = _tmp8_.height;
#line 471 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = clutter_actor_get_width ((ClutterActor*) self);
#line 471 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = _tmp9_;
#line 471 "../plugins/pip/PopupWindow.vala"
	off_screen_x_threshold = _tmp10_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 473 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = clutter_actor_get_x ((ClutterActor*) self);
#line 473 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = _tmp11_;
#line 473 "../plugins/pip/PopupWindow.vala"
	off_screen_x = (_tmp12_ - monitor_x) < (-off_screen_x_threshold);
#line 474 "../plugins/pip/PopupWindow.vala"
	if (off_screen_x) {
#line 1735 "PopupWindow.c"
		gfloat _tmp14_;
		gfloat _tmp15_;
#line 475 "../plugins/pip/PopupWindow.vala"
		_tmp14_ = clutter_actor_get_x ((ClutterActor*) self);
#line 475 "../plugins/pip/PopupWindow.vala"
		_tmp15_ = _tmp14_;
#line 475 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp15_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1744 "PopupWindow.c"
	} else {
#line 474 "../plugins/pip/PopupWindow.vala"
		_tmp13_ = FALSE;
#line 1748 "PopupWindow.c"
	}
#line 474 "../plugins/pip/PopupWindow.vala"
	if (_tmp13_) {
#line 1752 "PopupWindow.c"
		gfloat _tmp16_;
		gfloat _tmp17_;
#line 476 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 477 "../plugins/pip/PopupWindow.vala"
		_tmp16_ = clutter_actor_get_width ((ClutterActor*) self);
#line 477 "../plugins/pip/PopupWindow.vala"
		_tmp17_ = _tmp16_;
#line 477 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (monitor_x - _tmp17_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1763 "PopupWindow.c"
	}
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = clutter_actor_get_x ((ClutterActor*) self);
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = _tmp18_;
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = clutter_actor_get_width ((ClutterActor*) self);
#line 480 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = _tmp20_;
#line 480 "../plugins/pip/PopupWindow.vala"
	off_screen_w = (_tmp19_ + _tmp21_) > ((monitor_x + monitor_width) + off_screen_x_threshold);
#line 481 "../plugins/pip/PopupWindow.vala"
	if (off_screen_w) {
#line 1777 "PopupWindow.c"
		gfloat _tmp23_;
		gfloat _tmp24_;
		gfloat _tmp25_;
		gfloat _tmp26_;
#line 482 "../plugins/pip/PopupWindow.vala"
		_tmp23_ = clutter_actor_get_x ((ClutterActor*) self);
#line 482 "../plugins/pip/PopupWindow.vala"
		_tmp24_ = _tmp23_;
#line 482 "../plugins/pip/PopupWindow.vala"
		_tmp25_ = clutter_actor_get_width ((ClutterActor*) self);
#line 482 "../plugins/pip/PopupWindow.vala"
		_tmp26_ = _tmp25_;
#line 482 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp24_ + _tmp26_, CLUTTER_ORIENTATION_HORIZONTAL);
#line 1792 "PopupWindow.c"
	} else {
#line 481 "../plugins/pip/PopupWindow.vala"
		_tmp22_ = FALSE;
#line 1796 "PopupWindow.c"
	}
#line 481 "../plugins/pip/PopupWindow.vala"
	if (_tmp22_) {
#line 483 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 484 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_x ((ClutterActor*) self, (gfloat) ((monitor_x + monitor_width) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1804 "PopupWindow.c"
	}
#line 488 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = clutter_actor_get_height ((ClutterActor*) self);
#line 488 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = _tmp27_;
#line 488 "../plugins/pip/PopupWindow.vala"
	off_screen_y_threshold = _tmp28_ * GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_PERCENT;
#line 490 "../plugins/pip/PopupWindow.vala"
	_tmp29_ = clutter_actor_get_y ((ClutterActor*) self);
#line 490 "../plugins/pip/PopupWindow.vala"
	_tmp30_ = _tmp29_;
#line 490 "../plugins/pip/PopupWindow.vala"
	off_screen_y = (_tmp30_ - monitor_y) < (-off_screen_y_threshold);
#line 491 "../plugins/pip/PopupWindow.vala"
	if (off_screen_y) {
#line 1820 "PopupWindow.c"
		gfloat _tmp32_;
		gfloat _tmp33_;
#line 492 "../plugins/pip/PopupWindow.vala"
		_tmp32_ = clutter_actor_get_y ((ClutterActor*) self);
#line 492 "../plugins/pip/PopupWindow.vala"
		_tmp33_ = _tmp32_;
#line 492 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp33_, CLUTTER_ORIENTATION_VERTICAL);
#line 1829 "PopupWindow.c"
	} else {
#line 491 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = FALSE;
#line 1833 "PopupWindow.c"
	}
#line 491 "../plugins/pip/PopupWindow.vala"
	if (_tmp31_) {
#line 1837 "PopupWindow.c"
		gfloat _tmp34_;
		gfloat _tmp35_;
#line 493 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp34_ = clutter_actor_get_height ((ClutterActor*) self);
#line 494 "../plugins/pip/PopupWindow.vala"
		_tmp35_ = _tmp34_;
#line 494 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (monitor_y - _tmp35_) + GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS);
#line 1848 "PopupWindow.c"
	}
#line 497 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = clutter_actor_get_y ((ClutterActor*) self);
#line 497 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = _tmp36_;
#line 497 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = clutter_actor_get_height ((ClutterActor*) self);
#line 497 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = _tmp38_;
#line 497 "../plugins/pip/PopupWindow.vala"
	off_screen_h = (_tmp37_ + _tmp39_) > ((monitor_y + monitor_height) + off_screen_y_threshold);
#line 498 "../plugins/pip/PopupWindow.vala"
	if (off_screen_h) {
#line 1862 "PopupWindow.c"
		gfloat _tmp41_;
		gfloat _tmp42_;
		gfloat _tmp43_;
		gfloat _tmp44_;
#line 499 "../plugins/pip/PopupWindow.vala"
		_tmp41_ = clutter_actor_get_y ((ClutterActor*) self);
#line 499 "../plugins/pip/PopupWindow.vala"
		_tmp42_ = _tmp41_;
#line 499 "../plugins/pip/PopupWindow.vala"
		_tmp43_ = clutter_actor_get_height ((ClutterActor*) self);
#line 499 "../plugins/pip/PopupWindow.vala"
		_tmp44_ = _tmp43_;
#line 499 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = !gala_plugins_pip_popup_window_coord_is_in_other_monitor (self, _tmp42_ + _tmp44_, CLUTTER_ORIENTATION_VERTICAL);
#line 1877 "PopupWindow.c"
	} else {
#line 498 "../plugins/pip/PopupWindow.vala"
		_tmp40_ = FALSE;
#line 1881 "PopupWindow.c"
	}
#line 498 "../plugins/pip/PopupWindow.vala"
	if (_tmp40_) {
#line 500 "../plugins/pip/PopupWindow.vala"
		self->priv->off_screen = TRUE;
#line 501 "../plugins/pip/PopupWindow.vala"
		clutter_actor_set_y ((ClutterActor*) self, (gfloat) ((monitor_y + monitor_height) - GALA_PLUGINS_PIP_POPUP_WINDOW_OFF_SCREEN_VISIBLE_PIXELS));
#line 1889 "PopupWindow.c"
	}
#line 504 "../plugins/pip/PopupWindow.vala"
	clutter_actor_restore_easing_state ((ClutterActor*) self);
#line 506 "../plugins/pip/PopupWindow.vala"
	result = self->priv->off_screen;
#line 506 "../plugins/pip/PopupWindow.vala"
	return result;
#line 1897 "PopupWindow.c"
}

static gboolean
gala_plugins_pip_popup_window_coord_is_in_other_monitor (GalaPluginsPIPPopupWindow* self,
                                                         gfloat coord,
                                                         ClutterOrientation axis)
{
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	gint n_monitors = 0;
	MetaDisplay* _tmp3_;
	gint current = 0;
	MetaDisplay* _tmp4_;
	gboolean result;
#line 509 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 510 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 510 "../plugins/pip/PopupWindow.vala"
	display = _tmp2_;
#line 511 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = display;
#line 511 "../plugins/pip/PopupWindow.vala"
	n_monitors = meta_display_get_n_monitors (_tmp3_);
#line 513 "../plugins/pip/PopupWindow.vala"
	if (n_monitors == 1) {
#line 514 "../plugins/pip/PopupWindow.vala"
		result = FALSE;
#line 514 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (display);
#line 514 "../plugins/pip/PopupWindow.vala"
		return result;
#line 1936 "PopupWindow.c"
	}
#line 517 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = display;
#line 517 "../plugins/pip/PopupWindow.vala"
	current = meta_display_get_current_monitor (_tmp4_);
#line 1942 "PopupWindow.c"
	{
		gint i = 0;
#line 518 "../plugins/pip/PopupWindow.vala"
		i = 0;
#line 1947 "PopupWindow.c"
		{
			gboolean _tmp5_ = FALSE;
#line 518 "../plugins/pip/PopupWindow.vala"
			_tmp5_ = TRUE;
#line 518 "../plugins/pip/PopupWindow.vala"
			while (TRUE) {
#line 518 "../plugins/pip/PopupWindow.vala"
				if (!_tmp5_) {
#line 1956 "PopupWindow.c"
					gint _tmp6_;
#line 518 "../plugins/pip/PopupWindow.vala"
					_tmp6_ = i;
#line 518 "../plugins/pip/PopupWindow.vala"
					i = _tmp6_ + 1;
#line 1962 "PopupWindow.c"
				}
#line 518 "../plugins/pip/PopupWindow.vala"
				_tmp5_ = FALSE;
#line 518 "../plugins/pip/PopupWindow.vala"
				if (!(i < n_monitors)) {
#line 518 "../plugins/pip/PopupWindow.vala"
					break;
#line 1970 "PopupWindow.c"
				}
#line 519 "../plugins/pip/PopupWindow.vala"
				if (i != current) {
#line 1974 "PopupWindow.c"
					MtkRectangle monitor_rect = {0};
					MetaDisplay* _tmp7_;
					MtkRectangle _tmp8_ = {0};
					gboolean in_monitor = FALSE;
#line 520 "../plugins/pip/PopupWindow.vala"
					_tmp7_ = display;
#line 520 "../plugins/pip/PopupWindow.vala"
					meta_display_get_monitor_geometry (_tmp7_, i, &_tmp8_);
#line 520 "../plugins/pip/PopupWindow.vala"
					monitor_rect = _tmp8_;
#line 521 "../plugins/pip/PopupWindow.vala"
					in_monitor = FALSE;
#line 523 "../plugins/pip/PopupWindow.vala"
					if (axis == CLUTTER_ORIENTATION_HORIZONTAL) {
#line 1989 "PopupWindow.c"
						gboolean _tmp9_ = FALSE;
						MtkRectangle _tmp10_;
#line 524 "../plugins/pip/PopupWindow.vala"
						_tmp10_ = monitor_rect;
#line 524 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp10_.x)) {
#line 1996 "PopupWindow.c"
							MtkRectangle _tmp11_;
							MtkRectangle _tmp12_;
#line 524 "../plugins/pip/PopupWindow.vala"
							_tmp11_ = monitor_rect;
#line 524 "../plugins/pip/PopupWindow.vala"
							_tmp12_ = monitor_rect;
#line 524 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = coord <= ((gfloat) (_tmp11_.x + _tmp12_.width));
#line 2005 "PopupWindow.c"
						} else {
#line 524 "../plugins/pip/PopupWindow.vala"
							_tmp9_ = FALSE;
#line 2009 "PopupWindow.c"
						}
#line 524 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp9_;
#line 2013 "PopupWindow.c"
					} else {
						gboolean _tmp13_ = FALSE;
						MtkRectangle _tmp14_;
#line 526 "../plugins/pip/PopupWindow.vala"
						_tmp14_ = monitor_rect;
#line 526 "../plugins/pip/PopupWindow.vala"
						if (coord >= ((gfloat) _tmp14_.y)) {
#line 2021 "PopupWindow.c"
							MtkRectangle _tmp15_;
							MtkRectangle _tmp16_;
#line 526 "../plugins/pip/PopupWindow.vala"
							_tmp15_ = monitor_rect;
#line 526 "../plugins/pip/PopupWindow.vala"
							_tmp16_ = monitor_rect;
#line 526 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = coord <= ((gfloat) (_tmp15_.y + _tmp16_.height));
#line 2030 "PopupWindow.c"
						} else {
#line 526 "../plugins/pip/PopupWindow.vala"
							_tmp13_ = FALSE;
#line 2034 "PopupWindow.c"
						}
#line 526 "../plugins/pip/PopupWindow.vala"
						in_monitor = _tmp13_;
#line 2038 "PopupWindow.c"
					}
#line 529 "../plugins/pip/PopupWindow.vala"
					if (in_monitor) {
#line 530 "../plugins/pip/PopupWindow.vala"
						result = TRUE;
#line 530 "../plugins/pip/PopupWindow.vala"
						_g_object_unref0 (display);
#line 530 "../plugins/pip/PopupWindow.vala"
						return result;
#line 2048 "PopupWindow.c"
					}
				}
			}
		}
	}
#line 535 "../plugins/pip/PopupWindow.vala"
	result = FALSE;
#line 535 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (display);
#line 535 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2060 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_get_current_monitor_rect (GalaPluginsPIPPopupWindow* self,
                                                        MtkRectangle* rect)
{
	MtkRectangle _vala_rect = {0};
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	MetaDisplay* _tmp2_;
	MtkRectangle _tmp3_ = {0};
#line 539 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 543 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 543 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 543 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 543 "../plugins/pip/PopupWindow.vala"
	display = _tmp2_;
#line 544 "../plugins/pip/PopupWindow.vala"
	meta_display_get_monitor_geometry (display, meta_display_get_current_monitor (display), &_tmp3_);
#line 544 "../plugins/pip/PopupWindow.vala"
	_vala_rect = _tmp3_;
#line 539 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (display);
#line 539 "../plugins/pip/PopupWindow.vala"
	if (rect) {
#line 539 "../plugins/pip/PopupWindow.vala"
		*rect = _vala_rect;
#line 2093 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_get_target_window_size (GalaPluginsPIPPopupWindow* self,
                                                      gfloat* width,
                                                      gfloat* height)
{
	gfloat _vala_width = 0.0F;
	gfloat _vala_height = 0.0F;
#line 547 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 548 "../plugins/pip/PopupWindow.vala"
	if (self->priv->dynamic_container) {
#line 2108 "PopupWindow.c"
		ClutterActor* _tmp0_;
		gfloat _tmp1_ = 0.0F;
		gfloat _tmp2_ = 0.0F;
#line 549 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->container;
#line 549 "../plugins/pip/PopupWindow.vala"
		clutter_actor_get_clip (_tmp0_, NULL, NULL, &_tmp1_, &_tmp2_);
#line 549 "../plugins/pip/PopupWindow.vala"
		_vala_width = _tmp1_;
#line 549 "../plugins/pip/PopupWindow.vala"
		_vala_height = _tmp2_;
#line 2120 "PopupWindow.c"
	} else {
		ClutterActor* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 550 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = self->priv->clone;
#line 550 "../plugins/pip/PopupWindow.vala"
		g_object_get (_tmp3_, "has-clip", &_tmp4_, NULL);
#line 550 "../plugins/pip/PopupWindow.vala"
		_tmp5_ = _tmp4_;
#line 550 "../plugins/pip/PopupWindow.vala"
		if (_tmp5_) {
#line 2133 "PopupWindow.c"
			ClutterActor* _tmp6_;
			gfloat _tmp7_ = 0.0F;
			gfloat _tmp8_ = 0.0F;
#line 551 "../plugins/pip/PopupWindow.vala"
			_tmp6_ = self->priv->clone;
#line 551 "../plugins/pip/PopupWindow.vala"
			clutter_actor_get_clip (_tmp6_, NULL, NULL, &_tmp7_, &_tmp8_);
#line 551 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp7_;
#line 551 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp8_;
#line 2145 "PopupWindow.c"
		} else {
			ClutterActor* _tmp9_;
			gfloat _tmp10_;
			gfloat _tmp11_;
			ClutterActor* _tmp12_;
			gfloat _tmp13_;
			gfloat _tmp14_;
#line 553 "../plugins/pip/PopupWindow.vala"
			_tmp9_ = self->priv->clone;
#line 553 "../plugins/pip/PopupWindow.vala"
			_tmp10_ = clutter_actor_get_width (_tmp9_);
#line 553 "../plugins/pip/PopupWindow.vala"
			_tmp11_ = _tmp10_;
#line 553 "../plugins/pip/PopupWindow.vala"
			_vala_width = _tmp11_;
#line 554 "../plugins/pip/PopupWindow.vala"
			_tmp12_ = self->priv->clone;
#line 554 "../plugins/pip/PopupWindow.vala"
			_tmp13_ = clutter_actor_get_height (_tmp12_);
#line 554 "../plugins/pip/PopupWindow.vala"
			_tmp14_ = _tmp13_;
#line 554 "../plugins/pip/PopupWindow.vala"
			_vala_height = _tmp14_;
#line 2169 "PopupWindow.c"
		}
	}
#line 547 "../plugins/pip/PopupWindow.vala"
	if (width) {
#line 547 "../plugins/pip/PopupWindow.vala"
		*width = _vala_width;
#line 2176 "PopupWindow.c"
	}
#line 547 "../plugins/pip/PopupWindow.vala"
	if (height) {
#line 547 "../plugins/pip/PopupWindow.vala"
		*height = _vala_height;
#line 2182 "PopupWindow.c"
	}
}

static void
gala_plugins_pip_popup_window_activate (GalaPluginsPIPPopupWindow* self)
{
#line 558 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 559 "../plugins/pip/PopupWindow.vala"
	if (self->priv->off_screen) {
#line 560 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_place_window_in_screen (self);
#line 2195 "PopupWindow.c"
	} else {
		MetaWindow* window = NULL;
		MetaWindowActor* _tmp0_;
		MetaWindow* _tmp1_;
		MetaWindow* _tmp2_;
		MetaWindow* _tmp3_;
#line 562 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = self->priv->_window_actor;
#line 562 "../plugins/pip/PopupWindow.vala"
		_tmp1_ = meta_window_actor_get_meta_window (_tmp0_);
#line 562 "../plugins/pip/PopupWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 562 "../plugins/pip/PopupWindow.vala"
		window = _tmp2_;
#line 563 "../plugins/pip/PopupWindow.vala"
		_tmp3_ = window;
#line 563 "../plugins/pip/PopupWindow.vala"
		meta_window_activate (_tmp3_, clutter_get_current_event_time ());
#line 559 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (window);
#line 2216 "PopupWindow.c"
	}
}

GalaWindowManager*
gala_plugins_pip_popup_window_get_wm (GalaPluginsPIPPopupWindow* self)
{
	GalaWindowManager* result;
	GalaWindowManager* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 19 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2233 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_wm (GalaPluginsPIPPopupWindow* self,
                                      GalaWindowManager* value)
{
	GalaWindowManager* old_value;
#line 19 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_wm (self);
#line 19 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2247 "PopupWindow.c"
		GalaWindowManager* _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_wm);
#line 19 "../plugins/pip/PopupWindow.vala"
		self->priv->_wm = _tmp0_;
#line 19 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY]);
#line 2257 "PopupWindow.c"
	}
}

MetaWindowActor*
gala_plugins_pip_popup_window_get_window_actor (GalaPluginsPIPPopupWindow* self)
{
	MetaWindowActor* result;
	MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_window_actor;
#line 20 "../plugins/pip/PopupWindow.vala"
	result = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2274 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_set_window_actor (GalaPluginsPIPPopupWindow* self,
                                                MetaWindowActor* value)
{
	MetaWindowActor* old_value;
#line 20 "../plugins/pip/PopupWindow.vala"
	g_return_if_fail (self != NULL);
#line 20 "../plugins/pip/PopupWindow.vala"
	old_value = gala_plugins_pip_popup_window_get_window_actor (self);
#line 20 "../plugins/pip/PopupWindow.vala"
	if (old_value != value) {
#line 2288 "PopupWindow.c"
		MetaWindowActor* _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 20 "../plugins/pip/PopupWindow.vala"
		_g_object_unref0 (self->priv->_window_actor);
#line 20 "../plugins/pip/PopupWindow.vala"
		self->priv->_window_actor = _tmp0_;
#line 20 "../plugins/pip/PopupWindow.vala"
		g_object_notify_by_pspec ((GObject *) self, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY]);
#line 2298 "PopupWindow.c"
	}
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged (MetaWindow* _sender,
                                                                             gpointer self)
{
#line 73 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2308 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self)
{
#line 74 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2318 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed (MetaWorkspaceManager* _sender,
                                                                                                    gpointer self)
{
#line 77 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_window_focus ((GalaPluginsPIPPopupWindow*) self);
#line 2327 "PopupWindow.c"
}

static ClutterActor*
_gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin (GalaDragDropAction* _sender,
                                                                               gfloat x,
                                                                               gfloat y,
                                                                               gpointer self)
{
	ClutterActor* result;
	result = gala_plugins_pip_popup_window_on_move_begin ((GalaPluginsPIPPopupWindow*) self);
#line 82 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2340 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled (GalaDragDropAction* _sender,
                                                                                gpointer self)
{
#line 83 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_move_end ((GalaPluginsPIPPopupWindow*) self);
#line 2349 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked (GalaDragDropAction* _sender,
                                                                             guint32 button,
                                                                             gpointer self)
{
#line 84 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_activate ((GalaPluginsPIPPopupWindow*) self);
#line 2359 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered (GalaCloseButton* _sender,
                                                                                   guint32 timestamp,
                                                                                   gpointer self)
{
#line 119 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_close_click_clicked ((GalaPluginsPIPPopupWindow*) self);
#line 2369 "PopupWindow.c"
}

static gboolean
_gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event (ClutterActor* _sender,
                                                                                        ClutterEvent* event,
                                                                                        gpointer self)
{
	gboolean result;
	result = gala_plugins_pip_popup_window_on_resize_button_press ((GalaPluginsPIPPopupWindow*) self, event);
#line 126 "../plugins/pip/PopupWindow.vala"
	return result;
#line 2381 "PopupWindow.c"
}

static void
_gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self)
{
#line 132 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_on_allocation_changed ((GalaPluginsPIPPopupWindow*) self);
#line 2391 "PopupWindow.c"
}

static GObject *
gala_plugins_pip_popup_window_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GalaPluginsPIPPopupWindow * self;
	MetaDisplay* display = NULL;
	GalaWindowManager* _tmp0_;
	MetaDisplay* _tmp1_;
	gfloat scale = 0.0F;
	MetaDisplay* _tmp2_;
	MetaDisplay* _tmp3_;
	MetaWindow* window = NULL;
	MetaWindowActor* _tmp4_;
	MetaWindow* _tmp5_;
	MetaWindow* _tmp6_;
	MetaWindow* _tmp7_;
	MetaWorkspaceManager* workspace_manager = NULL;
	GalaWindowManager* _tmp8_;
	MetaDisplay* _tmp9_;
	MetaWorkspaceManager* _tmp10_;
	MetaWorkspaceManager* _tmp11_;
	MetaWindowActor* _tmp12_;
	ClutterClone* _tmp13_;
	GalaDragDropAction* _tmp14_;
	GalaDragDropAction* _tmp15_;
	GalaDragDropAction* _tmp16_;
	GalaDragDropAction* _tmp17_;
	ClutterActor* _tmp18_;
	ClutterActor* _tmp19_;
	ClutterActor* _tmp20_;
	ClutterActor* _tmp21_;
	gchar* _tmp22_;
	GalaShadowEffect* _tmp23_ = NULL;
	GalaShadowEffect* _tmp24_;
	ClutterActor* _tmp25_;
	ClutterActor* _tmp26_;
	ClutterActor* _tmp27_;
	GalaDragDropAction* _tmp28_;
	MtkRectangle monitor_rect = {0};
	MtkRectangle _tmp29_ = {0};
	gfloat x_position = 0.0F;
	gfloat y_position = 0.0F;
	MtkRectangle _tmp35_;
	MtkRectangle _tmp36_;
	gfloat _tmp37_;
	gfloat _tmp38_;
	GalaCloseButton* _tmp39_ = NULL;
	GalaCloseButton* _tmp40_;
	ClutterAlignConstraint* _tmp41_;
	ClutterAlignConstraint* _tmp42_;
	GalaCloseButton* _tmp43_;
	ClutterAlignConstraint* _tmp44_;
	ClutterAlignConstraint* _tmp45_;
	GalaCloseButton* _tmp46_;
	ClutterActor* _tmp47_;
	ClutterActor* _tmp48_;
	ClutterActor* _tmp49_;
	ClutterActor* _tmp50_;
	ClutterAlignConstraint* _tmp51_;
	ClutterAlignConstraint* _tmp52_;
	ClutterActor* _tmp53_;
	ClutterAlignConstraint* _tmp54_;
	ClutterAlignConstraint* _tmp55_;
	ClutterActor* _tmp56_;
	ClutterActor* _tmp57_;
	GalaCloseButton* _tmp58_;
	ClutterActor* _tmp59_;
	MetaWindowActor* _tmp60_;
	ClutterActor* _tmp61_;
#line 60 "../plugins/pip/PopupWindow.vala"
	parent_class = G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class);
#line 60 "../plugins/pip/PopupWindow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 60 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 61 "../plugins/pip/PopupWindow.vala"
	_tmp0_ = self->priv->_wm;
#line 61 "../plugins/pip/PopupWindow.vala"
	_tmp1_ = meta_plugin_get_display ((MetaPlugin*) _tmp0_);
#line 61 "../plugins/pip/PopupWindow.vala"
	display = _tmp1_;
#line 62 "../plugins/pip/PopupWindow.vala"
	_tmp2_ = display;
#line 62 "../plugins/pip/PopupWindow.vala"
	_tmp3_ = display;
#line 62 "../plugins/pip/PopupWindow.vala"
	scale = meta_display_get_monitor_scale (_tmp2_, meta_display_get_current_monitor (_tmp3_));
#line 64 "../plugins/pip/PopupWindow.vala"
	self->priv->button_size = gala_utils_scale_to_int (36, scale);
#line 65 "../plugins/pip/PopupWindow.vala"
	self->priv->container_margin = self->priv->button_size / 2;
#line 67 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive ((ClutterActor*) self, TRUE);
#line 69 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_pivot_point ((ClutterActor*) self, 0.5f, 0.5f);
#line 70 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_easing_mode ((ClutterActor*) self, CLUTTER_EASE_IN_QUAD);
#line 72 "../plugins/pip/PopupWindow.vala"
	_tmp4_ = self->priv->_window_actor;
#line 72 "../plugins/pip/PopupWindow.vala"
	_tmp5_ = meta_window_actor_get_meta_window (_tmp4_);
#line 72 "../plugins/pip/PopupWindow.vala"
	window = _tmp5_;
#line 73 "../plugins/pip/PopupWindow.vala"
	_tmp6_ = window;
#line 73 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp6_, "unmanaged", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_meta_window_unmanaged, self, 0);
#line 74 "../plugins/pip/PopupWindow.vala"
	_tmp7_ = window;
#line 74 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::appears-focused", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_g_object_notify, self, 0);
#line 76 "../plugins/pip/PopupWindow.vala"
	_tmp8_ = self->priv->_wm;
#line 76 "../plugins/pip/PopupWindow.vala"
	_tmp9_ = meta_plugin_get_display ((MetaPlugin*) _tmp8_);
#line 76 "../plugins/pip/PopupWindow.vala"
	_tmp10_ = meta_display_get_workspace_manager (_tmp9_);
#line 76 "../plugins/pip/PopupWindow.vala"
	workspace_manager = _tmp10_;
#line 77 "../plugins/pip/PopupWindow.vala"
	_tmp11_ = workspace_manager;
#line 77 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp11_, "active-workspace-changed", (GCallback) _gala_plugins_pip_popup_window_update_window_focus_meta_workspace_manager_active_workspace_changed, self, 0);
#line 79 "../plugins/pip/PopupWindow.vala"
	_tmp12_ = self->priv->_window_actor;
#line 79 "../plugins/pip/PopupWindow.vala"
	_tmp13_ = (ClutterClone*) clutter_clone_new ((ClutterActor*) _tmp12_);
#line 79 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp13_);
#line 79 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 79 "../plugins/pip/PopupWindow.vala"
	self->priv->clone = (ClutterActor*) _tmp13_;
#line 81 "../plugins/pip/PopupWindow.vala"
	_tmp14_ = gala_drag_drop_action_new (GALA_DRAG_DROP_ACTION_TYPE_SOURCE, "pip");
#line 81 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp14_);
#line 81 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 81 "../plugins/pip/PopupWindow.vala"
	self->priv->move_action = _tmp14_;
#line 82 "../plugins/pip/PopupWindow.vala"
	_tmp15_ = self->priv->move_action;
#line 82 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp15_, "drag-begin", (GCallback) _gala_plugins_pip_popup_window_on_move_begin_gala_drag_drop_action_drag_begin, self, 0);
#line 83 "../plugins/pip/PopupWindow.vala"
	_tmp16_ = self->priv->move_action;
#line 83 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp16_, "drag-canceled", (GCallback) _gala_plugins_pip_popup_window_on_move_end_gala_drag_drop_action_drag_canceled, self, 0);
#line 84 "../plugins/pip/PopupWindow.vala"
	_tmp17_ = self->priv->move_action;
#line 84 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp17_, "actor-clicked", (GCallback) _gala_plugins_pip_popup_window_activate_gala_drag_drop_action_actor_clicked, self, 0);
#line 86 "../plugins/pip/PopupWindow.vala"
	_tmp18_ = clutter_actor_new ();
#line 86 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp18_);
#line 86 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 86 "../plugins/pip/PopupWindow.vala"
	self->priv->container = _tmp18_;
#line 87 "../plugins/pip/PopupWindow.vala"
	_tmp19_ = self->priv->container;
#line 87 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp19_, TRUE);
#line 88 "../plugins/pip/PopupWindow.vala"
	_tmp20_ = self->priv->container;
#line 88 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_scale (_tmp20_, (gdouble) 0.35f, (gdouble) 0.35f);
#line 89 "../plugins/pip/PopupWindow.vala"
	_tmp21_ = self->priv->container;
#line 89 "../plugins/pip/PopupWindow.vala"
	_tmp22_ = g_strdup ("window-clone");
#line 89 "../plugins/pip/PopupWindow.vala"
	_tmp23_ = gala_shadow_effect_new (55);
#line 89 "../plugins/pip/PopupWindow.vala"
	gala_shadow_effect_set_css_class (_tmp23_, _tmp22_);
#line 89 "../plugins/pip/PopupWindow.vala"
	_g_free0 (_tmp22_);
#line 89 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp23_);
#line 89 "../plugins/pip/PopupWindow.vala"
	_tmp24_ = _tmp23_;
#line 89 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_effect (_tmp21_, (ClutterEffect*) _tmp24_);
#line 89 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp24_);
#line 90 "../plugins/pip/PopupWindow.vala"
	_tmp25_ = self->priv->container;
#line 90 "../plugins/pip/PopupWindow.vala"
	_tmp26_ = self->priv->clone;
#line 90 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child (_tmp25_, _tmp26_);
#line 91 "../plugins/pip/PopupWindow.vala"
	_tmp27_ = self->priv->container;
#line 91 "../plugins/pip/PopupWindow.vala"
	_tmp28_ = self->priv->move_action;
#line 91 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_action (_tmp27_, (ClutterAction*) _tmp28_);
#line 93 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_size (self);
#line 94 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_container_position (self);
#line 101 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_get_current_monitor_rect (self, &_tmp29_);
#line 101 "../plugins/pip/PopupWindow.vala"
	monitor_rect = _tmp29_;
#line 104 "../plugins/pip/PopupWindow.vala"
	if (clutter_get_default_text_direction () == CLUTTER_TEXT_DIRECTION_RTL) {
#line 2606 "PopupWindow.c"
		MtkRectangle _tmp30_;
#line 105 "../plugins/pip/PopupWindow.vala"
		_tmp30_ = monitor_rect;
#line 105 "../plugins/pip/PopupWindow.vala"
		x_position = (gfloat) (GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN + _tmp30_.x);
#line 2612 "PopupWindow.c"
	} else {
		MtkRectangle _tmp31_;
		MtkRectangle _tmp32_;
		gfloat _tmp33_;
		gfloat _tmp34_;
#line 107 "../plugins/pip/PopupWindow.vala"
		_tmp31_ = monitor_rect;
#line 107 "../plugins/pip/PopupWindow.vala"
		_tmp32_ = monitor_rect;
#line 107 "../plugins/pip/PopupWindow.vala"
		_tmp33_ = clutter_actor_get_width ((ClutterActor*) self);
#line 107 "../plugins/pip/PopupWindow.vala"
		_tmp34_ = _tmp33_;
#line 107 "../plugins/pip/PopupWindow.vala"
		x_position = ((_tmp31_.width + _tmp32_.x) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp34_;
#line 2628 "PopupWindow.c"
	}
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp35_ = monitor_rect;
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp36_ = monitor_rect;
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp37_ = clutter_actor_get_height ((ClutterActor*) self);
#line 109 "../plugins/pip/PopupWindow.vala"
	_tmp38_ = _tmp37_;
#line 109 "../plugins/pip/PopupWindow.vala"
	y_position = ((_tmp35_.height + _tmp36_.y) - GALA_PLUGINS_PIP_POPUP_WINDOW_SCREEN_MARGIN) - _tmp38_;
#line 111 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position ((ClutterActor*) self, x_position, y_position);
#line 113 "../plugins/pip/PopupWindow.vala"
	_tmp39_ = gala_close_button_new (scale);
#line 113 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity ((ClutterActor*) _tmp39_, (guint) 0);
#line 113 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp39_);
#line 113 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 113 "../plugins/pip/PopupWindow.vala"
	self->priv->close_button = _tmp39_;
#line 117 "../plugins/pip/PopupWindow.vala"
	_tmp40_ = self->priv->close_button;
#line 117 "../plugins/pip/PopupWindow.vala"
	_tmp41_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 0.0f);
#line 117 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp41_);
#line 117 "../plugins/pip/PopupWindow.vala"
	_tmp42_ = _tmp41_;
#line 117 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp40_, (ClutterConstraint*) _tmp42_);
#line 117 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp42_);
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp43_ = self->priv->close_button;
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp44_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 0.0f);
#line 118 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp44_);
#line 118 "../plugins/pip/PopupWindow.vala"
	_tmp45_ = _tmp44_;
#line 118 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint ((ClutterActor*) _tmp43_, (ClutterConstraint*) _tmp45_);
#line 118 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp45_);
#line 119 "../plugins/pip/PopupWindow.vala"
	_tmp46_ = self->priv->close_button;
#line 119 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp46_, "triggered", (GCallback) _gala_plugins_pip_popup_window_on_close_click_clicked_gala_close_button_triggered, self, 0);
#line 121 "../plugins/pip/PopupWindow.vala"
	_tmp47_ = gala_utils_create_resize_button (scale);
#line 121 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 121 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_button = _tmp47_;
#line 122 "../plugins/pip/PopupWindow.vala"
	_tmp48_ = self->priv->resize_button;
#line 122 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_opacity (_tmp48_, (guint) 0);
#line 123 "../plugins/pip/PopupWindow.vala"
	_tmp49_ = self->priv->resize_button;
#line 123 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_reactive (_tmp49_, TRUE);
#line 124 "../plugins/pip/PopupWindow.vala"
	_tmp50_ = self->priv->resize_button;
#line 124 "../plugins/pip/PopupWindow.vala"
	_tmp51_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_X_AXIS, 1.0f);
#line 124 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp51_);
#line 124 "../plugins/pip/PopupWindow.vala"
	_tmp52_ = _tmp51_;
#line 124 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp50_, (ClutterConstraint*) _tmp52_);
#line 124 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp52_);
#line 125 "../plugins/pip/PopupWindow.vala"
	_tmp53_ = self->priv->resize_button;
#line 125 "../plugins/pip/PopupWindow.vala"
	_tmp54_ = (ClutterAlignConstraint*) clutter_align_constraint_new ((ClutterActor*) self, CLUTTER_ALIGN_Y_AXIS, 1.0f);
#line 125 "../plugins/pip/PopupWindow.vala"
	g_object_ref_sink (_tmp54_);
#line 125 "../plugins/pip/PopupWindow.vala"
	_tmp55_ = _tmp54_;
#line 125 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_constraint (_tmp53_, (ClutterConstraint*) _tmp55_);
#line 125 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (_tmp55_);
#line 126 "../plugins/pip/PopupWindow.vala"
	_tmp56_ = self->priv->resize_button;
#line 126 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object (_tmp56_, "button-press-event", (GCallback) _gala_plugins_pip_popup_window_on_resize_button_press_clutter_actor_button_press_event, self, 0);
#line 128 "../plugins/pip/PopupWindow.vala"
	_tmp57_ = self->priv->container;
#line 128 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp57_);
#line 129 "../plugins/pip/PopupWindow.vala"
	_tmp58_ = self->priv->close_button;
#line 129 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, (ClutterActor*) _tmp58_);
#line 130 "../plugins/pip/PopupWindow.vala"
	_tmp59_ = self->priv->resize_button;
#line 130 "../plugins/pip/PopupWindow.vala"
	clutter_actor_add_child ((ClutterActor*) self, _tmp59_);
#line 132 "../plugins/pip/PopupWindow.vala"
	_tmp60_ = self->priv->_window_actor;
#line 132 "../plugins/pip/PopupWindow.vala"
	g_signal_connect_object ((GObject*) _tmp60_, "notify::allocation", (GCallback) _gala_plugins_pip_popup_window_on_allocation_changed_g_object_notify, self, 0);
#line 133 "../plugins/pip/PopupWindow.vala"
	_tmp61_ = self->priv->container;
#line 133 "../plugins/pip/PopupWindow.vala"
	clutter_actor_set_position (_tmp61_, (gfloat) self->priv->container_margin, (gfloat) self->priv->container_margin);
#line 134 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_update_clone_clip (self);
#line 60 "../plugins/pip/PopupWindow.vala"
	return obj;
#line 2746 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_class_init (GalaPluginsPIPPopupWindowClass * klass,
                                          gpointer klass_data)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_parent_class = g_type_class_peek_parent (klass);
#line 7 "../plugins/pip/PopupWindow.vala"
	g_type_class_adjust_private_offset (klass, &GalaPluginsPIPPopupWindow_private_offset);
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->show = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_show;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->hide = (void (*) (ClutterActor*)) gala_plugins_pip_popup_window_real_hide;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->enter_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_enter_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	((ClutterActorClass *) klass)->leave_event = (gboolean (*) (ClutterActor*, ClutterEvent*)) gala_plugins_pip_popup_window_real_leave_event;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_gala_plugins_pip_popup_window_get_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_gala_plugins_pip_popup_window_set_property;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->constructor = gala_plugins_pip_popup_window_constructor;
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = gala_plugins_pip_popup_window_finalize;
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY] = g_param_spec_object ("wm", "wm", "wm", GALA_TYPE_WINDOW_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY, gala_plugins_pip_popup_window_properties[GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY] = g_param_spec_object ("window-actor", "window-actor", "window-actor", meta_window_actor_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 7 "../plugins/pip/PopupWindow.vala"
	gala_plugins_pip_popup_window_signals[GALA_PLUGINS_PIP_POPUP_WINDOW_CLOSED_SIGNAL] = g_signal_new ("closed", GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2779 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_instance_init (GalaPluginsPIPPopupWindow * self,
                                             gpointer klass)
{
#line 7 "../plugins/pip/PopupWindow.vala"
	self->priv = gala_plugins_pip_popup_window_get_instance_private (self);
#line 22 "../plugins/pip/PopupWindow.vala"
	self->priv->dynamic_container = FALSE;
#line 30 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_width = 0.0f;
#line 31 "../plugins/pip/PopupWindow.vala"
	self->priv->begin_resize_height = 0.0f;
#line 32 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_x = 0.0f;
#line 33 "../plugins/pip/PopupWindow.vala"
	self->priv->resize_start_y = 0.0f;
#line 35 "../plugins/pip/PopupWindow.vala"
	self->priv->resizing = FALSE;
#line 36 "../plugins/pip/PopupWindow.vala"
	self->priv->off_screen = FALSE;
#line 37 "../plugins/pip/PopupWindow.vala"
	self->priv->grab = NULL;
#line 2804 "PopupWindow.c"
}

static void
gala_plugins_pip_popup_window_finalize (GObject * obj)
{
	GalaPluginsPIPPopupWindow * self;
#line 7 "../plugins/pip/PopupWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 19 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_wm);
#line 20 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->_window_actor);
#line 24 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->clone);
#line 25 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->container);
#line 26 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->close_button);
#line 27 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->resize_button);
#line 28 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->move_action);
#line 37 "../plugins/pip/PopupWindow.vala"
	_g_object_unref0 (self->priv->grab);
#line 7 "../plugins/pip/PopupWindow.vala"
	G_OBJECT_CLASS (gala_plugins_pip_popup_window_parent_class)->finalize (obj);
#line 2831 "PopupWindow.c"
}

static GType
gala_plugins_pip_popup_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GalaPluginsPIPPopupWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gala_plugins_pip_popup_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GalaPluginsPIPPopupWindow), 0, (GInstanceInitFunc) gala_plugins_pip_popup_window_instance_init, NULL };
	GType gala_plugins_pip_popup_window_type_id;
	gala_plugins_pip_popup_window_type_id = g_type_register_static (clutter_actor_get_type (), "GalaPluginsPIPPopupWindow", &g_define_type_info, 0);
	GalaPluginsPIPPopupWindow_private_offset = g_type_add_instance_private (gala_plugins_pip_popup_window_type_id, sizeof (GalaPluginsPIPPopupWindowPrivate));
	return gala_plugins_pip_popup_window_type_id;
}

GType
gala_plugins_pip_popup_window_get_type (void)
{
	static volatile gsize gala_plugins_pip_popup_window_type_id__once = 0;
	if (g_once_init_enter (&gala_plugins_pip_popup_window_type_id__once)) {
		GType gala_plugins_pip_popup_window_type_id;
		gala_plugins_pip_popup_window_type_id = gala_plugins_pip_popup_window_get_type_once ();
		g_once_init_leave (&gala_plugins_pip_popup_window_type_id__once, gala_plugins_pip_popup_window_type_id);
	}
	return gala_plugins_pip_popup_window_type_id__once;
}

static void
_vala_gala_plugins_pip_popup_window_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_wm (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		g_value_set_object (value, gala_plugins_pip_popup_window_get_window_actor (self));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2878 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2884 "PopupWindow.c"
	}
}

static void
_vala_gala_plugins_pip_popup_window_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	GalaPluginsPIPPopupWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GALA_PLUGINS_PIP_TYPE_POPUP_WINDOW, GalaPluginsPIPPopupWindow);
#line 7 "../plugins/pip/PopupWindow.vala"
	switch (property_id) {
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WM_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_wm (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 7 "../plugins/pip/PopupWindow.vala"
		case GALA_PLUGINS_PIP_POPUP_WINDOW_WINDOW_ACTOR_PROPERTY:
#line 7 "../plugins/pip/PopupWindow.vala"
		gala_plugins_pip_popup_window_set_window_actor (self, g_value_get_object (value));
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2910 "PopupWindow.c"
		default:
#line 7 "../plugins/pip/PopupWindow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 7 "../plugins/pip/PopupWindow.vala"
		break;
#line 2916 "PopupWindow.c"
	}
}

